#ifndef _DS18B20_																//    
#define _DS18B20_

#ifndef F_CPU
# warning "F_CPU not defined. Frequency by default 16MHz"
#define F_CPU 16000000UL		/*     (     )*/
#endif

#include <util/delay.h>														//   
#include "1Wire.h"															//    1wire

//===========       DS18B20 =============
// :
//0x00-       ,    0xFF

char DS18B20_Conversion(void)
{
	if (w1_init()!=1) return 0xFF;											//  (        )
	
	w1_write(0xCC);															// " "
	w1_write(0x44);															// " "
	_delay_ms(750);															// 750    
	return 0;
}

//===      DS18B20      ===
// :
//*addr- 64-  
// *addr   0,    ( 0xCC " ")
// :
//       .   -  
//     ( ,      , 
//        ),
//   0xFC19.

int DS18B20_Read(void *addr)
{
	char buf[9];															//    
	int i;																	// 
	__volatile__ char *p;													// 
	p=addr;																	//    
	
	if (w1_init()!=1) return 0xFC19;										// 
	w1_write(0x55);															// " "
	
	p=addr;																	//    
	for (i=0;i<8; i++) w1_write(*(p++));									// 64- 

	w1_write(0xBE);			 												// "  "
	for (i=0; i<9; i++) buf[i]=w1_read();									//  

	if (buf[8]==w1_crc8(buf,8)) return buf[0]+(buf[1]<<8);					//    ,    
	else return 0xFC19;
}

//====      DS18B20     =====
// :
//*addr- 64-  
// *addr   0,    ( 0xCC " ")
// :
//        .
//    10  . ..     234,
//   23.4 .   -    
//  ( ,      ,    
//    ),    -999.

int DS18B20_temperature(void *addr)
{
	int temperature;
	
	temperature=DS18B20_Read(addr);											// 
	if (temperature!=0xFC19) return temperature*0.625+0.5;					//    
	else return -999;
}
#endif