#ifdef TIMER2

#ifndef F_CPU
# warning "F_CPU not defined. Frequency by default 16MHz"
#define F_CPU 16000000UL														/*     (     )*/
#endif

#include <avr/iom128.h>															//  /
#include <avr/interrupt.h>														//  

//=======         ==========
SIGNAL(TIMER2_COMP_vect)
{
#ifdef _KEY_TIMER2_
//--------------------------     -----------------------------
	if ((PIND & (1<<PD7))==0) _Key_flags|=0x01;									//     
	if ((PIND & (1<<PD6))==0) _Key_flags|=0x02;
	if ((PIND & (1<<PD4))==0) _Key_flags|=0x04;
#endif

#ifdef _SHIM_TIMER2_	
//-------------------------------    ----------------------------------
//--------------------    6  - --------------------
#ifdef _IO_6_ENABLE_
	if (_ShimPulse[0]!=0)
	{
		_ShimCount[0]++;														//   
		if (_ShimCount[0]<_ShimPeriod[0])										//   
		{
			if (_ShimCount[0]>=_ShimPulse[0]) PORTE&=~(1<<PE3);					//     ,  
		}
		else
		{
			_ShimCount[0]=0;													//      
			PORTE|=(1<<PE3);													//   (  )
		}
	}
	if (_ShimPulse[1]!=0)
	{
		_ShimCount[1]++;														//   
		if (_ShimCount[1]<_ShimPeriod[1])										//   
		{
			if (_ShimCount[1]>=_ShimPulse[1]) PORTE&=~(1<<PE4);					//     ,  
		}
		else
		{
			_ShimCount[1]=0;													//      
			PORTE|=(1<<PE4);													//   (  )
		}
	}
	if (_ShimPulse[2]!=0)
	{
		_ShimCount[2]++;														//   
		if (_ShimCount[2]<_ShimPeriod[2])										//   
		{
			if (_ShimCount[2]>=_ShimPulse[2]) PORTE&=~(1<<PE5);					//     ,  
		}	
		else
		{
			_ShimCount[2]=0;													//      
			PORTE|=(1<<PE5);													//   (  )
		}
	}
	if (_ShimPulse[3]!=0)
	{
		_ShimCount[3]++;														//   
		if (_ShimCount[3]<_ShimPeriod[3])										//   
		{
			if (_ShimCount[3]>=_ShimPulse[3]) PORTB&=~(1<<PB5);					//     ,  
		}
		else
		{
			_ShimCount[3]=0;													//      
			PORTB|=(1<<PB5);													//   (  )
		}
	}
	if (_ShimPulse[4]!=0)
	{
		_ShimCount[4]++;														//   
		if (_ShimCount[4]<_ShimPeriod[4])										//   
		{
			if (_ShimCount[4]>=_ShimPulse[4]) PORTB&=~(1<<PB6);					//     ,  
		}
		else
		{
			_ShimCount[4]=0;													//      
			PORTB|=(1<<PB6);													//   (  )
		}
	}
	if (_ShimPulse[5]!=0)
	{
		_ShimCount[5]++;														//   
		if (_ShimCount[5]<_ShimPeriod[5])										//   
		{
			if (_ShimCount[5]>=_ShimPulse[5]) PORTB&=~(1<<PB7);					//     ,  
		}
		else
		{
			_ShimCount[5]=0;													//      
			PORTB|=(1<<PB7);													//   (  )
		}
	}
#endif
//-------------------    16  - --------------------
#ifdef _IO_16_ENABLE_
	if (_ShimPulse[0]!=0)
	{
		_ShimCount[0]++;														//   
		if (_ShimCount[0]<_ShimPeriod[0])										//   
		{
			if (_ShimCount[0]>=_ShimPulse[0]) PORTB&=~(1<<PB4);					//     ,  
		}
		else
		{
			_ShimCount[0]=0;													//      
			PORTB|=(1<<PB4);													//   (  )
		}
	}
	if (_ShimPulse[1]!=0)
	{
		_ShimCount[1]++;														//   
		if (_ShimCount[1]<_ShimPeriod[1])										//   
		{
			if (_ShimCount[1]>=_ShimPulse[1]) PORTF&=~(1<<PF6);					//     ,  
		}
		else
		{
			_ShimCount[1]=0;													//      
			PORTF|=(1<<PF6);													//   (  )
		}
	}
	if (_ShimPulse[2]!=0)
	{
		_ShimCount[2]++;														//   
		if (_ShimCount[2]<_ShimPeriod[2])										//   
		{
			if (_ShimCount[2]>=_ShimPulse[2]) PORTF&=~(1<<PF5);					//     ,  
		}
		else
		{
			_ShimCount[2]=0;													//      
			PORTF|=(1<<PF5);													//   (  )
		}
	}
	if (_ShimPulse[3]!=0)
	{
		_ShimCount[3]++;														//   
		if (_ShimCount[3]<_ShimPeriod[3])										//   
		{
			if (_ShimCount[3]>=_ShimPulse[3]) PORTF&=~(1<<PF4);					//     ,  
		}
		else
		{
			_ShimCount[3]=0;													//      
			PORTF|=(1<<PF4);													//   (  )
		}
	}
	if (_ShimPulse[4]!=0)
	{
		_ShimCount[4]++;														//   
		if (_ShimCount[4]<_ShimPeriod[4])										//   
		{
			if (_ShimCount[4]>=_ShimPulse[4]) PORTF&=~(1<<PF3);					//     ,  
		}
		else
		{
			_ShimCount[4]=0;													//      
			PORTF|=(1<<PF3);													//   (  )
		}
	}
	if (_ShimPulse[5]!=0)
	{
		_ShimCount[5]++;														//   
		if (_ShimCount[5]<_ShimPeriod[5])										//   
		{
			if (_ShimCount[5]>=_ShimPulse[5]) PORTF&=~(1<<PF2);					//     ,  
		}
		else
		{
			_ShimCount[5]=0;													//      
			PORTF|=(1<<PF2);													//   (  )
		}
	}
#endif
#endif
}
	
//==============================    2 =================================
void _Timer2_Enable(void)
{
	OCR2=(float)F_CPU/1000/64+0.5;												//    (  1 /)
	TIMSK|=(1<<OCIE2);															//    2 
	TCCR2=(1<<WGM21)|(1<<CS21)|(1<<CS20);										//  2   "  ".   64.
	sei();
}
#endif
